/**
 *
 */
package de.intevation.gnv.transition;

import java.io.OutputStream;
import java.util.Collection;

import org.w3c.dom.Document;

import de.intevation.artifacts.CallMeta;
import de.intevation.gnv.transition.exception.TransitionException;

/**
 * @author Tim Englich <tim.englich@intevation.de>
 * 
 */
public interface OutputTransition extends Transition {

    /**
     * Returns the Rendered Result of an Transition.
     * 
     * @param outputMode
     *            The Mode that should be produces (Chart, Map, ...)
     * @return The Bytecode of the Result
     * @throws TransitionException
     */
    public void out(Document format, Collection<InputData> inputData,
                    OutputStream outputStream, String uuid, CallMeta callMeta)
                                                                              throws TransitionException;

    /**
     * Delivers the provided OutputModes of an Transition
     * 
     * @return the provided OutputModes of an Transition
     */
    public Collection<OutputMode> getOutputModes();
}
